###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildhugemem 1
%define buildlargesmp 1
%define buildxen 1
%define kernel_version 2.6.9-55.0.12.EL
%define subversion 46

%ifnarch i686 x86_64
%define buildsmp 0
%define buildxen 0
%endif 

%ifnarch i686
%define buildhugemem 0
%endif

%ifnarch x86_64 ia64 ppc64
%define buildlargesmp 0
%endif

Name: dlm-kernel
Version: 2.6.9
Release: 46.16.0.11
License: GPL
Group: System Environment/Kernel
Summary: dlm-kernel - The Distributed Lock Manager kernel modules.
BuildRequires: cman-kernheaders >= 2.6.9
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: cman-kernel >= 2.6.9

%if %{buildsmp}
BuildRequires: kernel-smp-devel = %{kernel_version}
BuildRequires: cman-kernel-smp >= 2.6.9
%endif

%if %{buildhugemem}
BuildRequires: cman-kernel-hugemem >= 2.6.9
BuildRequires: kernel-hugemem-devel = %{kernel_version}
%endif

%if %{buildlargesmp}
BuildRequires: kernel-largesmp-devel = %{kernel_version}
BuildRequires: cman-kernel-largesmp >= 2.6.9
%endif

%if %{buildxen}
BuildRequires: kernel-xenU-devel = %{kernel_version}
BuildRequires: cman-kernel-xenU >= 2.6.9
%endif

Conflicts: GFS <= 6.0
Conflicts: GFS-modules GFS-module-smp GFS-module-hugemem
Requires: kernel = %{kernel_version}
Requires: cman-kernel >= 2.6.9
Requires: /lib/modules/%{kernel_version}
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}
ExclusiveArch: i686 ia64 x86_64 ppc64
Source0: %{name}-%{version}-%{subversion}.tar.gz
Patch0: dlm-kernel-sec-fix-bz248957.patch
Patch1: dlm-kernel-proc-dlm-locks.patch
Patch2: dlm-kernel-sec-fix-bz248957-2.patch
Patch3: dlm-kernel-sec-fix-bz248957-3.patch
Patch4: pf-device-bz319671.patch
Patch5: assertion-bz301511.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
dlm-kernel - The Distributed Lock Manager kernel modules.

%package -n dlm-kernheaders
Group: Development/System
Summary: dlm kernel header files

%description -n dlm-kernheaders
The dlm kernel headers are used by various cluster packages.

%if %{buildsmp}
%package -n dlm-kernel-smp
Group: System Environment/Kernel
Summary: dlm-kernel-smp - The Distributed Lock Manager kernel modules.
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Requires: cman-kernel-smp >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-smp
dlm-kernel-smp - The Distributed Lock Manager kernel-smp modules.
%endif

%if %{buildhugemem}
%package -n dlm-kernel-hugemem
Group: System Environment/Kernel
Summary: dlm-kernel-hugemem - The Distributed Lock Manager kernel modules.
Requires: kernel-hugemem = %{kernel_version}
Requires: /lib/modules/%{kernel_version}hugemem
Requires: cman-kernel-hugemem >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-hugemem
dlm-kernel-hugemem - The Distributed Lock Manager kernel-hugemem modules.
%endif

%if %{buildlargesmp}
%package -n dlm-kernel-largesmp
Group: System Environment/Kernel
Summary: dlm-kernel-largesmp - The Distributed Lock Manager kernel modules.
Requires: kernel-largesmp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}largesmp
Requires: cman-kernel-largesmp >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-largesmp
dlm-kernel-largesmp - The Distributed Lock Manager kernel-largesmp modules.
%endif

%if %{buildxen}
%package -n dlm-kernel-xenU
Group: System Environment/Kernel
Summary: dlm-kernel-xenU - The Distributed Lock Manager kernel modules.
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Requires: cman-kernel-xenU >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-xenU
dlm-kernel-xenU - The Distributed Lock Manager kernel-xenU modules.
%endif

################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n %{name}-%{version}-%{subversion}
sed  -i -e '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' \
       src/dlm_internal.h	
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p0
%patch5 -p0

################################################################################
##  THE BUILD SECTION
################################################################################
%build

ROOT_DIR_FILES=`ls`
mkdir up
mv  $ROOT_DIR_FILES up
cp -r up smp
cp -r up hugemem
cp -r up largesmp
cp -r up xenU

Build_dlm(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build/
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo "Kernel %{kernel_version} found."
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

	./configure --kernel_src=$kernel_src --incdir=%{_includedir}
	make symverfile=/lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers
	ls -l /lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers
	$kernel_src/scripts/mod/modpost -m -i /lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers src/dlm.o -o dlm.symvers
}

%if %{buildup}
cd up
Build_dlm %{_target_cpu}
cd ..
%endif

%if %{buildsmp}
cd smp
Build_dlm %{_target_cpu} smp
cd ..
%endif

%if %{buildhugemem}
cd hugemem
Build_dlm %{_target_cpu} hugemem
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
Build_dlm %{_target_cpu} largesmp
cd ..
%endif

%if %{buildxen}
cd xenU
Build_dlm %{_target_cpu} xenU
cd ..
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
cd up
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/kernel/cluster/
cd ..
%endif
                                                                                
%if %{buildsmp}
cd smp
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}smp/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}smp/kernel/cluster/
cd ..
%endif

%if %{buildhugemem}
cd hugemem
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}hugemem/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}hugemem/kernel/cluster/
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}largesmp/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}largesmp/kernel/cluster/
cd ..
%endif

%if %{buildxen}
cd xenU
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}xenU/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}xenU/kernel/cluster/
cd ..
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildhugemem}
%post hugemem
/sbin/depmod -e %{kernel_version}hugemem
%endif

%if %{buildlargesmp}
%post largesmp
/sbin/depmod -e %{kernel_version}largesmp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%endif

%files
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}/kernel/cluster/*

%if %{buildsmp}
%files -n dlm-kernel-smp
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}smp/kernel/cluster/*
%endif

%if %{buildhugemem}
%files -n dlm-kernel-hugemem
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}hugemem/kernel/cluster/*
%endif

%if %{buildlargesmp}
%files -n dlm-kernel-largesmp
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}largesmp/kernel/cluster/*
%endif

%if %{buildxen}
%files -n dlm-kernel-xenU
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}xenU/kernel/cluster/*
%endif

%files -n dlm-kernheaders
%defattr(-,root,root,-)
%{_includedir}/cluster/*

%changelog
* Thu Oct 18 2007 Chris Feist <cfeist@redhat.com>
- Built for 55.0.12.EL
- Resolves: rhbz#338881

* Mon Oct 01 2007 Chris Feist <cfeist@redhat.com>
- Fixed a bug which could leave locks hanging around even when the userland
  process that was using them exits.
- Removed a spurious assertion.
- Resolves: rhbz#301511 rhbz#319671

* Tue Sep 25 2007 Chris Feist <cfeist@redhat.com>
- Built for 55.0.9.EL
- Resolves: rhbz#305881

* Tue Aug 14 2007 Chris Feist <cfeist@redhat.com>
- Built for 55.0.6.EL
- Resolves: rhbz#250319

* Mon Aug 13 2007 Chris Feist <cfeist@redhat.com>
- Fixed fix for rhbz#248957
- Resolves: rhbz#248957

* Mon Aug 06 2007 Chris Feist <cfeist@redhat.com>
- Fixed fix for rhbz#248957
- Resolves: rhbz#248957

* Tue Jul 31 2007 Chris Feist <cfeist@redhat.com>
- Built for 55.0.3.EL
- Fixes problem which would could cause viewing /proc/cluster/dlm_locks
  to crash the system
- Resolves: rhbz#250319 rhbz#250156

* Fri Jul 20 2007 Chris Feist <cfeist@redhat.com>
- Fixes a problem which causes a TCP connection to the DLM port to block
  DLM operations.
- Resolves: rhbz#248957

* Thu Jun 14 2007 Chris Feist <cfeist@redhat.com>
- Built for 55.0.2.EL
- Resolves: rhbz#244252

* Fri Jan 12 2007 Chris Feist <cfeist@redhat.com>
- Built for xenU kernel

* Wed Dec 20 2006 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-42.0.4.EL kernel

* Fri Apr 21 2006 Chris Feist <cfeist@redhat.com>
- Added support for largesmp kernel.

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provide dlm-kernel-modules.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriplet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleaned up .spec file. 

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Fri Oct 22 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Aug 16 2004 Jon Brassow <jbrassow@redhat.com>
- add requires field

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com>
- smp was building but not being packaged
- specify more packages that conflict with this one

* Fri Aug 13 2004 Jon Brassow <jbrassow@redhat.com>
- various bug fixes (new upstream sources)
- no need for make file patch

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- update patch for a Makefile

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- add patch for a Makefile

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- be more explicit in files section

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- bump rev number and fix typo

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
